package com.example.beacondemo.Activity;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.Bundle;
import android.provider.SyncStateContract;
import android.text.Html;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.example.beacondemo.R;
import com.example.beacondemo.adapter.RecycleAdapter;
import com.minew.beaconplus.sdk.MTCentralManager;
import com.minew.beaconplus.sdk.MTConnectionFeature;
import com.minew.beaconplus.sdk.MTConnectionHandler;
import com.minew.beaconplus.sdk.MTFrameHandler;
import com.minew.beaconplus.sdk.MTPeripheral;
import com.minew.beaconplus.sdk.enums.ConnectState;
import com.minew.beaconplus.sdk.enums.FeatureSupported;
import com.minew.beaconplus.sdk.enums.FrameType;
import com.minew.beaconplus.sdk.enums.PasswordState;
import com.minew.beaconplus.sdk.enums.TriggerType;
import com.minew.beaconplus.sdk.enums.Version;
import com.minew.beaconplus.sdk.exception.MTException;
import com.minew.beaconplus.sdk.frames.AccFrame;
import com.minew.beaconplus.sdk.frames.ForceFrame;
import com.minew.beaconplus.sdk.frames.HTFrame;
import com.minew.beaconplus.sdk.frames.IBeaconFrame;
import com.minew.beaconplus.sdk.frames.InfoFrame;
import com.minew.beaconplus.sdk.frames.LightFrame;
import com.minew.beaconplus.sdk.frames.LineBeaconFrame;
import com.minew.beaconplus.sdk.frames.MinewFrame;
import com.minew.beaconplus.sdk.frames.PIRFrame;
import com.minew.beaconplus.sdk.frames.TamperProofFrame;
import com.minew.beaconplus.sdk.frames.TemperatureFrame;
import com.minew.beaconplus.sdk.frames.TlmFrame;
import com.minew.beaconplus.sdk.frames.TvocFrame;
import com.minew.beaconplus.sdk.frames.UidFrame;
import com.minew.beaconplus.sdk.frames.UrlFrame;
import com.minew.beaconplus.sdk.interfaces.MTCentralManagerListener;
import com.minew.beaconplus.sdk.interfaces.SetTriggerListener;
import com.minew.beaconplus.sdk.model.Trigger;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class DetailActivity extends AppCompatActivity implements View.OnClickListener {

    private MTPeripheral mtPeripheral;

    private MTConnectionHandler mMTConnectionHandler;

    private MTCentralManager mMtCentralManager;

    private View ivBack;

    private TextView tvSet;

    int mCurSlot = 2;

    TextView txt_name,txt_mac,txt_battery,txt_rssi,txt_device,txt_xaxis,txt_yaxis,txt_zaxis;
    String mac,name,xaxis,yaxis,zaxis;;
    int battery,rssi;

    private RecycleAdapter mAdapter;

    RecyclerView mRecycle;

    ArrayList<MinewFrame> advFrames;
    TextView tv_resetPass;
    EditText edtPassR,edtConPassR;

    SharedPreferences sharedPreferences;
    private static final String KEY_PASS= "password";
    private static final String SHARED_PREF_NAME = "myPref";


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_detail);

        sharedPreferences = getSharedPreferences(SHARED_PREF_NAME,MODE_PRIVATE);



        initView();
        initData();
        initListener();


        tv_resetPass.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                resetPassword();
            }
        });

    }

    @SuppressLint("MissingInflatedId")
    public void resetPassword() {
        final AlertDialog.Builder dialogBuilder = new AlertDialog.Builder(this);
        LayoutInflater inflater = this.getLayoutInflater();
        dialogBuilder.setCancelable(false);
        final View dialogView = inflater.inflate(R.layout.password_reset, null);
        dialogBuilder.setView(dialogView);
        edtPassR =  dialogView.findViewById(R.id.edtPassR);
        edtConPassR =  dialogView.findViewById(R.id.edtConPassR);

        //System.out.println("Value of userPass "+String.valueOf(userPass));
        dialogBuilder.setPositiveButton("SUBMIT", null);
        dialogBuilder.setTitle("Reset Password");
        dialogBuilder.setMessage("Please enter password to you want to reset.");

        dialogBuilder.setNegativeButton("CANCEL",null);
        final AlertDialog b = dialogBuilder.create();
        b.show();
        Button positiveButton = b.getButton(AlertDialog.BUTTON_POSITIVE);
        Button cancel = b.getButton(AlertDialog.BUTTON_NEGATIVE);
        positiveButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                String pass = edtPassR.getText().toString();
                String conpass = edtConPassR.getText().toString();
                System.out.println(pass + " " + conpass);

                if(pass.equals(conpass) ){
                    Intent intent = new Intent(DetailActivity.this,MainActivity.class);
                    intent.putExtra("password",pass);
                    SharedPreferences.Editor editor = sharedPreferences.edit();
                    editor.putString(KEY_PASS,null);
                    editor.apply();
                    startActivity(intent);

                }
                else{
                    Toast.makeText(DetailActivity.this, "Passwords dont match", Toast.LENGTH_SHORT).show();
                }

            }
        });
        cancel.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                b.dismiss();
            }
        });
    }

    private void initView() {
        ivBack = findViewById(R.id.iv_back);
        tvSet = findViewById(R.id.tv_set);

        txt_battery=findViewById(R.id.txt_battery);
        txt_mac=findViewById(R.id.txt_mac);
        txt_name=findViewById(R.id.txt_name);
        txt_rssi=findViewById(R.id.txt_rssi);
        txt_device=findViewById(R.id.txt_device);
        txt_xaxis=findViewById(R.id.txt_xaxis);
        txt_yaxis=findViewById(R.id.txt_yaxis);
        txt_zaxis=findViewById(R.id.txt_zaxis);

        mRecycle = findViewById(R.id.recycle);
        tv_resetPass = findViewById(R.id.tv_resetPass);


        Intent intent = getIntent();
        String mac = intent.getStringExtra("mac");
        String name = intent.getStringExtra("name");
        int battery = intent.getIntExtra("battery",0);
        int rssi = intent.getIntExtra("rssi",0);

        System.out.println("Value of battery and rssi in DetailActivity : " + battery + " " + rssi );
        String xaxis = intent.getStringExtra("xaxis");
        String yaxis = intent.getStringExtra("yaxis");
        String zaxis = intent.getStringExtra("zaxis");

        txt_mac.setText("Mac Address : "+mac);
        txt_name.setText("Device Name : "+name);
        txt_rssi.setText("Battery Status : "+ String.valueOf(rssi));
        txt_battery.setText(" Rssi : "+String.valueOf(battery));
        txt_xaxis.setText("X axis: " +xaxis);
        txt_yaxis.setText("Y axis: " +yaxis);
        txt_zaxis.setText("Z axis: " +zaxis);
        txt_device.setText("Device in range. ");
        txt_device.setTextColor(Color.BLUE);

        RecyclerView.LayoutManager layoutManager = new LinearLayoutManager(this);
        mRecycle.setLayoutManager(layoutManager);
        mAdapter = new RecycleAdapter();
        mRecycle.setAdapter(mAdapter);

    }

    private void initData() {
        mtPeripheral = MainActivity.mtPeripheral;
        mMTConnectionHandler = mtPeripheral.mMTConnectionHandler;
        mMtCentralManager = MTCentralManager.getInstance(this);

        mMtCentralManager.startScan();
        mMtCentralManager.setMTCentralManagerListener(new MTCentralManagerListener() {
            @Override
            public void onScanedPeripheral(final List<MTPeripheral> peripherals) {
                Log.e("Peripherals : ", String.valueOf(peripherals.size()));
                mAdapter.setData(peripherals);
                for (MTPeripheral mtPeripheral : peripherals) {
                    // get FrameHandler of a device.
                    MTFrameHandler mtFrameHandler = mtPeripheral.mMTFrameHandler;
                    mac = mtFrameHandler.getMac(); 		//mac address of device
                    name = mtFrameHandler.getName();		// name of device
                    battery = mtFrameHandler.getBattery();	//battery
                    rssi = mtFrameHandler.getRssi();		//rssi
                    txt_device.setText("Device in range. ");
                    txt_device.setTextColor(Color.BLUE);

                    String html1 = "<font color=" + Color.BLACK
                            + ">Mac Address : </font><font color="
                            + Color.BLACK + ">"+ mac+"</font>";

                    txt_mac.setText(Html.fromHtml(html1));

                    System.out.println("Value of battery and rssi in MainActivity : " + battery + " " + rssi );

                    txt_name.setText("Device Name : "+name);
                    txt_battery.setText("Battery Status : "+battery);
                    txt_rssi.setText(" Rssi : "+rssi);


                    // all data frames of device（such as:iBeacon，UID，URL...）
                    advFrames = mtFrameHandler.getAdvFrames();
                    Log.v("Device Log : ", advFrames.toString());
                    for (MinewFrame minewFrame : advFrames) {
                        FrameType frameType = minewFrame.getFrameType();
                        switch (frameType) {
                            case FrameiBeacon://iBeacon
                                IBeaconFrame iBeaconFrame = (IBeaconFrame) minewFrame;
                                Log.v("beaconplus1", iBeaconFrame.getUuid() + " "+ iBeaconFrame.getMajor() + " "+ iBeaconFrame.getMinor());
                                break;
                            case FrameUID://uid
                                UidFrame uidFrame = (UidFrame) minewFrame;
                                Log.v("beaconplus2", uidFrame.getNamespaceId() + uidFrame.getInstanceId());
                                break;
                            case FrameAccSensor:
                                AccFrame accFrame = (AccFrame) minewFrame;//acc
                                xaxis = String.valueOf(accFrame.getXAxis());
                                yaxis = String.valueOf(accFrame.getYAxis());
                                zaxis = String.valueOf(accFrame.getZAxis());




                                txt_xaxis.setText("X axis: " + xaxis);
                                txt_yaxis.setText("Y axis: " + yaxis);
                                txt_zaxis.setText("Z axis: " + zaxis);

                                if (accFrame.getXAxis() == Double.MIN_VALUE) {
                                    Log.v("tag","this value is not available.");
                                }
                                if (accFrame.getYAxis() == Double.MIN_VALUE) {
                                    Log.v("tag","this value is not available.");
                                }
                                if (accFrame.getZAxis() == Double.MIN_VALUE) {
                                    Log.v("tag","this value is not available.");
                                }
                                Log.v("beaconplus3", String.valueOf(accFrame.getXAxis() + " "+ accFrame.getYAxis() +" "+ accFrame.getZAxis()));
                                break;
                            case FrameHTSensor:
                                HTFrame htFrame = (HTFrame) minewFrame;//ht
                                Log.v("beaconplus4", String.valueOf(htFrame.getTemperature() + " "+ htFrame.getHumidity()));
                                break;
                            case FrameTLM:
                                TlmFrame tlmFrame = (TlmFrame) minewFrame;//tlm
                                Log.v("beaconplus5", String.valueOf(tlmFrame.getTemperature() + " "+ tlmFrame.getBatteryVol() + " "+ tlmFrame.getSecCount() + " "+ tlmFrame.getAdvCount()));
                                break;
                            case FrameURL:
                                UrlFrame urlFrame = (UrlFrame) minewFrame;//url
                                Log.v("beaconplus6", "Link:" + urlFrame.getUrlString() + "Rssi @ 0m:" + urlFrame.getTxPower());
                                break;
                            case FrameLightSensor:
                                LightFrame lightFrame = (LightFrame) minewFrame;//light
                                Log.v("beaconplus7", "battery:" + lightFrame.getBattery() + "%" + lightFrame.getLuxValue());
                                break;
                            case FrameForceSensor:
                                ForceFrame forceFrame = ((ForceFrame) minewFrame);//force
                                Log.v("beaconplus8", "battery:" + forceFrame.getBattery() + "%" + "force:" +  forceFrame.getForce() + "gram");
                                break;
                            case FramePIRSensor:
                                PIRFrame pirFrame = ((PIRFrame) minewFrame);//pir
                                Log.v("beaconplus9", "battery:" + pirFrame.getBattery() + "%" + "PIR:"+ pirFrame.getPirData());
                                break;
                            case FrameTempSensor://temp
                                TemperatureFrame temperatureFrame = (TemperatureFrame) minewFrame;
                                Log.v("beaconplus10", "battery:" + temperatureFrame.getBattery() + "%,temperature:" + String.format("%.2f", temperatureFrame.getValue()) + "°C");
                                break;
                            case FrameTVOCSensor://tvoc
                                TvocFrame tvocFrame = (TvocFrame) minewFrame;
                                Log.v("beaconplus11", "battery:" + tvocFrame.getBattery() + " "+ ",TVOC:"+ tvocFrame.getValue() + " "+ "ppb," + "battery:"+ " "+ +tvocFrame.getBattery() + "mV");
                                break;
                            case FrameLineBeacon://FrameLineBeacon
                                LineBeaconFrame lineBeacon = ((LineBeaconFrame) minewFrame);
                                Log.v("beaconplus12", "Hwid:" + lineBeacon.getHwid()
                                        +" "+  ",Rssi@1m:"+ lineBeacon.getTxPower()
                                        +" "+  ",authentication:"+lineBeacon.getAuthentication()
                                        +" "+  ",timesTamp:" + lineBeacon.getTimesTamp());
                                break;
                            case FrameTamperProof://TamperProofFrame
                                TamperProofFrame tamperProofFrame = ((TamperProofFrame) minewFrame);//
                                Log.v("beaconplus13", "battery:" + tamperProofFrame.getBattery());
                                break;
                            case FrameDeviceInfo://InfoFrame
                                InfoFrame infoFrame = ((InfoFrame) minewFrame);//
                                Log.v("beaconplus14", infoFrame.getMajor() +" "+  infoFrame.getMinor() + 	" "+ infoFrame.getBatteryVoltage());
                                break;
                            default:
                                Log.v("Device range", "Device not found");


                                break;
                        }
                    }




                }

            }

            @Override
            public boolean equals(@Nullable Object obj) {
                Log.e("Equals", "equals");
                return super.equals(obj);
            }


            @Override
            protected void finalize() throws Throwable {
                Log.e("Finalize", "finalize");
                super.finalize();
            }

            @Override
            public int hashCode() {
                Log.e("HashCode", "hashCode");
                return super.hashCode();
            }

            @NonNull
            @Override
            protected Object clone() throws CloneNotSupportedException {
                Log.e("Clone", "clone");
                return super.clone();
            }

            @NonNull
            @Override
            public String toString() {
                Log.e("ToString", "toString");
                return super.toString();
            }
        });

        /*MTConnectionHandler mtConnectionHandler = mtPeripheral.mMTConnectionHandler;
        ConnectState connectState = mtConnectionHandler.getConnectState();
        // password require or not. None, Require
        PasswordState passwordState = mMTConnectionHandler.getPasswordState();
        // device info, such as：（Firmware Version： 0.9.1）;
        HashMap<String, String> systeminfos = (HashMap<String, String>) mMTConnectionHandler.systeminfos;
        String manufacturer = systeminfos.get(SyncStateContract.Constants.manufacturer);
        String modlenumber = systeminfos.get(Constants.modlenumber);
        String macAddress = systeminfos.get(Constants.serialnumber);
        String hardware = systeminfos.get(Constants.hardware);
        String firmware = systeminfos.get(Constants.firmware);
        String software = systeminfos.get(Constants.software);*/

        // device features
        /*MTConnectionFeature mtConnectionFeature = mMTConnectionHandler.mTConnectionFeature;
        // atitude of slot(s),
        int slotAtitude = mtConnectionFeature.getSlotAtitude();
        Log.d("slotAtitude", String.valueOf(slotAtitude));
        // parameters can be modified：none，adv,txpower,adv/txpower
        FeatureSupported featureSupported = mtConnectionFeature.getFeatureSupported();
        Log.d("featureSupported", String.valueOf(featureSupported));
        // // frames supported（multiple）
        List<FrameType> supportedSlots = mtConnectionFeature.getSupportedSlots();
        Log.d("supportedSlots", String.valueOf(supportedSlots));
        // Txpower supported（multiple）
        byte[] supportedTxpowers = mtConnectionFeature.getSupportedTxpowers();
        Log.d("supportedTxpowers", String.valueOf(supportedTxpowers));
        // trigger supported（multiple）
        ArrayList<TriggerType> supportTriggers = (ArrayList<TriggerType>) mtConnectionFeature.supportTriggers;
        Log.d("supportTriggers", String.valueOf(supportTriggers));
        // Version of firmware;
        Version version = mtConnectionFeature.getVersion();
        Log.d("version", String.valueOf(version));*/
    }

    private void initListener() {
        ivBack.setOnClickListener(this);
        tvSet.setOnClickListener(this);
    }

    public void saveTrigger() {
        System.out.println("Inside save trigger method");
        Version version = this.mMTConnectionHandler.mTConnectionFeature.getVersion();
        System.out.println("Version Inside save trigger method" +  version.getValue());
        if (version.getValue() >= 4) {
            if (this.mMTConnectionHandler.mTConnectionFeature.supportTriggers.size() > 0
                    && this.mMTConnectionHandler.triggers.size() > 0) {
                Trigger trigger = new Trigger();
                trigger.setCurSlot(mCurSlot);
                boolean isOpen = true;
                if (isOpen) {
                    TriggerType triggerType = TriggerType.BTN_DTAP_EVT;
                    trigger.setTriggerType(TriggerType.BTN_DTAP_EVT);
                    switch (triggerType) {
                        case TEMPERATURE_ABOVE_ALARM:
                        case TEMPERATURE_BELOW_ALARM:
                        case HUMIDITY_ABOVE_ALRM:
                        case HUMIDITY_BELOW_ALRM:
                        case LIGHT_ABOVE_ALRM:
                        case LIGHT_BELOW_ALARM:
                        case FORCE_ABOVE_ALRM:
                        case FORCE_BELOW_ALRM:
                        case TVOC_ABOVE_ALARM:
                        case TVOC_BELOW_ALARM:
                            trigger.setCondition(10);
                            break;
                        default:
                            trigger.setCondition(10 * 1000);
                    }
                } else {
                    trigger.setTriggerType(TriggerType.TRIGGER_SRC_NONE);
                    trigger.setCondition(0);
                }
                if (version.getValue() > 4) {
                    trigger.setAdvInterval(2000);
                    trigger.setRadioTxpower(0);
                    trigger.setAlwaysAdvertising(false);
                }
                this.mMTConnectionHandler.setTriggerCondition(trigger, new SetTriggerListener() {
                    @Override
                    public void onSetTrigger(boolean success, MTException mtException) {
                        //Monitor whether the write is successful
                        Log.e("minew_tag","trigger success " + success);
                    }
                });
            }
        }
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()) {
            case R.id.iv_back:
                mMtCentralManager.disconnect(mtPeripheral);
                finish();
                break;
            case R.id.tv_set:
                saveTrigger();
                break;
            default:
                break;
        }

    }


}