package com.example.beacondemo.Activity;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import android.Manifest;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothManager;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.os.Build;
import android.os.Bundle;
import android.text.Html;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.example.beacondemo.BindView;
import com.example.beacondemo.R;
import com.example.beacondemo.adapter.RecycleAdapter;
import com.example.beacondemo.adapter.RecycleViewDivider;
import com.minew.beaconplus.sdk.MTCentralManager;
import com.minew.beaconplus.sdk.MTFrameHandler;
import com.minew.beaconplus.sdk.MTPeripheral;
import com.minew.beaconplus.sdk.Utils.LogUtils;
import com.minew.beaconplus.sdk.enums.BluetoothState;
import com.minew.beaconplus.sdk.enums.ConnectionStatus;
import com.minew.beaconplus.sdk.enums.FrameType;
import com.minew.beaconplus.sdk.exception.MTException;
import com.minew.beaconplus.sdk.frames.AccFrame;
import com.minew.beaconplus.sdk.frames.ForceFrame;
import com.minew.beaconplus.sdk.frames.HTFrame;
import com.minew.beaconplus.sdk.frames.IBeaconFrame;
import com.minew.beaconplus.sdk.frames.InfoFrame;
import com.minew.beaconplus.sdk.frames.LightFrame;
import com.minew.beaconplus.sdk.frames.LineBeaconFrame;
import com.minew.beaconplus.sdk.frames.MinewFrame;
import com.minew.beaconplus.sdk.frames.PIRFrame;
import com.minew.beaconplus.sdk.frames.TamperProofFrame;
import com.minew.beaconplus.sdk.frames.TemperatureFrame;
import com.minew.beaconplus.sdk.frames.TlmFrame;
import com.minew.beaconplus.sdk.frames.TvocFrame;
import com.minew.beaconplus.sdk.frames.UidFrame;
import com.minew.beaconplus.sdk.frames.UrlFrame;
import com.minew.beaconplus.sdk.interfaces.ConnectionStatueListener;
import com.minew.beaconplus.sdk.interfaces.GetPasswordListener;
import com.minew.beaconplus.sdk.interfaces.MTCentralManagerListener;
import com.minew.beaconplus.sdk.interfaces.OnBluetoothStateChangedListener;

import java.util.ArrayList;
import java.util.List;

import cn.pedant.SweetAlert.SweetAlertDialog;

public class MainActivity extends AppCompatActivity {

    private static final int REQUEST_ENABLE_BT = 3;
    private static final int PERMISSION_COARSE_LOCATION = 2;

    //@BindView(R.id.recycle)
    RecyclerView mRecycle;

    private MTCentralManager mMtCentralManager;

    private RecycleAdapter mAdapter;

    List<MTPeripheral> mtPeripherals = new ArrayList<>();

    public static MTPeripheral mtPeripheral;
    private static final int REQUEST_FINE_LOCATION = 125;

    ArrayList<MinewFrame> advFrames;

    TextView txt_name,txt_mac,txt_battery,txt_rssi,txt_device,txt_xaxis,txt_yaxis,txt_zaxis;
    String mac,name,xaxis,yaxis,zaxis;
    int battery,rssi;

    EditText edtPass;
    boolean passwordGiven=false;

    SharedPreferences sharedPreferences;
    private static final String SHARED_PREF_NAME = "myPref";
    private static final String KEY_PASS= "password";

    String passAvail = "test";
    String newPass = "";



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        //ButterKnife.bind(this);
        mRecycle = findViewById(R.id.recycle);

        sharedPreferences = getSharedPreferences(SHARED_PREF_NAME,MODE_PRIVATE);
        passAvail = sharedPreferences.getString(KEY_PASS,null);
        System.out.println("Value of passAvail "+ passAvail);

        Intent intent = getIntent();
        newPass = intent.getStringExtra("password");
        System.out.println("Value of newPass22 " + newPass);


        if (!ensureBleExists())
            finish();

        initView();
        initManager();
        getRequiredPermissions();
        initListener();
        scanDevice();
    }

    private void scanDevice(){

    }

    private boolean ensureBleExists() {
        if (!getPackageManager().hasSystemFeature(PackageManager.FEATURE_BLUETOOTH_LE)) {
            Toast.makeText(this, "Phone does not support BLE", Toast.LENGTH_LONG).show();
            return false;
        }
        return true;
    }

    protected boolean isBLEEnabled() {
        final BluetoothManager bluetoothManager = (BluetoothManager) getSystemService(Context.BLUETOOTH_SERVICE);
        final BluetoothAdapter adapter = bluetoothManager.getAdapter();
        return adapter != null && adapter.isEnabled();
    }

    @SuppressLint("MissingPermission")
    private void showBLEDialog() {
        System.out.println("Hitting the dialog box");
        final Intent enableIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
        startActivityForResult(enableIntent, REQUEST_ENABLE_BT);
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        if (requestCode == REQUEST_ENABLE_BT) {
            if (resultCode == Activity.RESULT_OK) {
                initData();
            } else {
                finish();
            }
        }
    }

    private void initData() {

        mMtCentralManager.startScan();
        mMtCentralManager.setMTCentralManagerListener(new MTCentralManagerListener() {
            @Override
            public void onScanedPeripheral(final List<MTPeripheral> peripherals) {
                Log.e("Peripherals : ", String.valueOf(peripherals.size()));
                mAdapter.setData(peripherals);
                for (MTPeripheral mtPeripheral : peripherals) {
                    // get FrameHandler of a device.
                    MTFrameHandler mtFrameHandler = mtPeripheral.mMTFrameHandler;
                     mac = mtFrameHandler.getMac(); 		//mac address of device
                     name = mtFrameHandler.getName();		// name of device
                     battery = mtFrameHandler.getBattery();	//battery
                     rssi = mtFrameHandler.getRssi();		//rssi
                     txt_device.setText("Device in range. ");
                     txt_device.setTextColor(Color.BLUE);

                    String html1 = "<font color=" + Color.BLACK
                            + ">Mac Address : </font><font color="
                            + Color.BLACK + ">"+ mac+"</font>";

                    txt_mac.setText(Html.fromHtml(html1));

                    System.out.println("Value of battery and rssi in MainActivity : " + battery + " " + rssi );

                    txt_name.setText("Device Name : "+name);
                    txt_battery.setText("Battery Status : "+battery);
                    txt_rssi.setText(" Rssi : "+rssi);


                    // all data frames of device（such as:iBeacon，UID，URL...）
                    advFrames = mtFrameHandler.getAdvFrames();
                    Log.v("Device Log : ", advFrames.toString());
                    for (MinewFrame minewFrame : advFrames) {
                        FrameType frameType = minewFrame.getFrameType();
                        switch (frameType) {
                            case FrameiBeacon://iBeacon
                                IBeaconFrame iBeaconFrame = (IBeaconFrame) minewFrame;
                                Log.v("beaconplus1", iBeaconFrame.getUuid() + " "+ iBeaconFrame.getMajor() + " "+ iBeaconFrame.getMinor());
                                break;
                            case FrameUID://uid
                                UidFrame uidFrame = (UidFrame) minewFrame;
                                Log.v("beaconplus2", uidFrame.getNamespaceId() + uidFrame.getInstanceId());
                                break;
                            case FrameAccSensor:
                                AccFrame accFrame = (AccFrame) minewFrame;//acc
                                xaxis = String.valueOf(accFrame.getXAxis());
                                yaxis = String.valueOf(accFrame.getYAxis());
                                zaxis = String.valueOf(accFrame.getZAxis());




                                txt_xaxis.setText("X axis: " + xaxis);
                                txt_yaxis.setText("Y axis: " + yaxis);
                                txt_zaxis.setText("Z axis: " + zaxis);

                                if (accFrame.getXAxis() == Double.MIN_VALUE) {
                                    Log.v("tag","this value is not available.");
                                }
                                if (accFrame.getYAxis() == Double.MIN_VALUE) {
                                    Log.v("tag","this value is not available.");
                                }
                                if (accFrame.getZAxis() == Double.MIN_VALUE) {
                                    Log.v("tag","this value is not available.");
                                }
                                Log.v("beaconplus3", String.valueOf(accFrame.getXAxis() + " "+ accFrame.getYAxis() +" "+ accFrame.getZAxis()));
                                break;
                            case FrameHTSensor:
                                HTFrame htFrame = (HTFrame) minewFrame;//ht
                                Log.v("beaconplus4", String.valueOf(htFrame.getTemperature() + " "+ htFrame.getHumidity()));
                                break;
                            case FrameTLM:
                                TlmFrame tlmFrame = (TlmFrame) minewFrame;//tlm
                                Log.v("beaconplus5", String.valueOf(tlmFrame.getTemperature() + " "+ tlmFrame.getBatteryVol() + " "+ tlmFrame.getSecCount() + " "+ tlmFrame.getAdvCount()));
                                break;
                            case FrameURL:
                                UrlFrame urlFrame = (UrlFrame) minewFrame;//url
                                Log.v("beaconplus6", "Link:" + urlFrame.getUrlString() + "Rssi @ 0m:" + urlFrame.getTxPower());
                                break;
                            case FrameLightSensor:
                                LightFrame lightFrame = (LightFrame) minewFrame;//light
                                Log.v("beaconplus7", "battery:" + lightFrame.getBattery() + "%" + lightFrame.getLuxValue());
                                break;
                            case FrameForceSensor:
                                ForceFrame forceFrame = ((ForceFrame) minewFrame);//force
                                Log.v("beaconplus8", "battery:" + forceFrame.getBattery() + "%" + "force:" +  forceFrame.getForce() + "gram");
                                break;
                            case FramePIRSensor:
                                PIRFrame pirFrame = ((PIRFrame) minewFrame);//pir
                                Log.v("beaconplus9", "battery:" + pirFrame.getBattery() + "%" + "PIR:"+ pirFrame.getPirData());
                                break;
                            case FrameTempSensor://temp
                                TemperatureFrame temperatureFrame = (TemperatureFrame) minewFrame;
                                Log.v("beaconplus10", "battery:" + temperatureFrame.getBattery() + "%,temperature:" + String.format("%.2f", temperatureFrame.getValue()) + "°C");
                                break;
                            case FrameTVOCSensor://tvoc
                                TvocFrame tvocFrame = (TvocFrame) minewFrame;
                                Log.v("beaconplus11", "battery:" + tvocFrame.getBattery() + " "+ ",TVOC:"+ tvocFrame.getValue() + " "+ "ppb," + "battery:"+ " "+ +tvocFrame.getBattery() + "mV");
                                break;
                            case FrameLineBeacon://FrameLineBeacon
                                LineBeaconFrame lineBeacon = ((LineBeaconFrame) minewFrame);
                                Log.v("beaconplus12", "Hwid:" + lineBeacon.getHwid()
                                        +" "+  ",Rssi@1m:"+ lineBeacon.getTxPower()
                                        +" "+  ",authentication:"+lineBeacon.getAuthentication()
                                        +" "+  ",timesTamp:" + lineBeacon.getTimesTamp());
                                break;
                            case FrameTamperProof://TamperProofFrame
                                TamperProofFrame tamperProofFrame = ((TamperProofFrame) minewFrame);//
                                Log.v("beaconplus13", "battery:" + tamperProofFrame.getBattery());
                                break;
                            case FrameDeviceInfo://InfoFrame
                                InfoFrame infoFrame = ((InfoFrame) minewFrame);//
                                Log.v("beaconplus14", infoFrame.getMajor() +" "+  infoFrame.getMinor() + 	" "+ infoFrame.getBatteryVoltage());
                                break;
                            default:
                                Log.v("Device range", "Device not found");


                                break;
                        }
                    }
                }

            }

            @Override
            public boolean equals(@Nullable Object obj) {
                Log.e("Equals", "equals");
                return super.equals(obj);
            }


            @Override
            protected void finalize() throws Throwable {
                Log.e("Finalize", "finalize");
                super.finalize();
            }

            @Override
            public int hashCode() {
                Log.e("HashCode", "hashCode");
                return super.hashCode();
            }

            @NonNull
            @Override
            protected Object clone() throws CloneNotSupportedException {
                Log.e("Clone", "clone");
                return super.clone();
            }

            @NonNull
            @Override
            public String toString() {
                Log.e("ToString", "toString");
                return super.toString();
            }
        });

        /*mMtCentralManager.connect(mtPeripheral,connectionStatueListener);
        ConnectionStatueListener connectionStatueListener = new ConnectionStatueListener(){
            @Override
            public void onUpdateConnectionStatus(final ConnectionStatus connectionStatus,final GetPasswordListener getPasswordListener) {
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        switch (connectionStatus){
                            case PASSWORDVALIDATING:
                                String password = "minew123";
                                getPasswordListener.getPassword(password);
                                break;
                        }
                        switch (connectionStatus) {
                            case CONNECTING:
                                Log.e("minew_tag", ": CONNECTING");
                                break;
                            case CONNECTED:
                                Log.e("minew_tag", ": CONNECTED");
                                break;
                            case READINGINFO:
                                //Advanced exercise can be notified when reading firmware 								  information
                                Log.e("minew_tag", ": Read device firmware information");
                                break;
                            case DEVICEVALIDATING://After successfully verifying the device, 											write the verification key to the device
                                LogUtils.e("DEVICEVALIDATING");
                                break;
                            case PASSWORDVALIDATING:
                                String password = "minew123";
                                getPasswordListener.getPassword(password);
                                break;
                            case SYNCHRONIZINGTIME://Password verification completed
                                Log.e("minew_tag", ": SYNCHRONIZINGTIME");
                                break;
                            case READINGCONNECTABLE:
                                Log.e("minew_tag", ": Read device firmware information");
                                LogUtils.e("READINGCONNECTABLE");
                                break;
                            case READINGFEATURE:
                                LogUtils.e("READINGFEATURE");
                                break;
                            case READINGFRAMES:
                                LogUtils.e("READINGFRAMES");
                                break;
                            case READINGTRIGGERS:
                                LogUtils.e("READINGTRIGGERS");
                                break;
                            case READINGSENSORS:
                                LogUtils.e("READINGSENSORS");
                                break;
                            case COMPLETED:
                                //At this point the connection is successful and the 									parameters are written to the device
                                break;
                        }
                    }
                });

            }

            @Override
            public void onError(MTException e) {

            }
        };

        mMtCentralManager.disconnect(mtPeripheral);*/

    }

    private void initView() {
        txt_battery=findViewById(R.id.txt_battery);
        txt_mac=findViewById(R.id.txt_mac);
        txt_name=findViewById(R.id.txt_name);
        txt_rssi=findViewById(R.id.txt_rssi);
        txt_device=findViewById(R.id.txt_device);
        txt_xaxis=findViewById(R.id.txt_xaxis);
        txt_yaxis=findViewById(R.id.txt_yaxis);
        txt_zaxis=findViewById(R.id.txt_zaxis);
        RecyclerView.LayoutManager layoutManager = new LinearLayoutManager(this);
        mRecycle.setLayoutManager(layoutManager);
        mAdapter = new RecycleAdapter();
        mRecycle.setAdapter(mAdapter);
        System.out.println("Data is set in recyclerview through the adapter");
        /*mRecycle.addItemDecoration(new RecycleViewDivider(this, LinearLayoutManager
                .HORIZONTAL));*/
    }

    private void initManager() {
        mMtCentralManager = MTCentralManager.getInstance(this);
        //startservice
        mMtCentralManager.startService();
        BluetoothState bluetoothState = mMtCentralManager.getBluetoothState(this);
        switch (bluetoothState) {
            case BluetoothStateNotSupported:
                Log.e("tag", "BluetoothStateNotSupported");
                break;
            case BluetoothStatePowerOff:
                Log.e("tag", "BluetoothStatePowerOff");

                break;
            case BluetoothStatePowerOn:
                Log.e("tag", "BluetoothStatePowerOn");
                break;
        }

        mMtCentralManager.setBluetoothChangedListener(new OnBluetoothStateChangedListener() {
            @Override
            public void onStateChanged(BluetoothState state) {
                switch (state) {
                    case BluetoothStateNotSupported:
                        Log.e("tag", "BluetoothStateNotSupported");
                        break;
                    case BluetoothStatePowerOff:
                        Log.e("tag", "BluetoothStatePowerOff");
                        showBLEDialog();
                        break;
                    case BluetoothStatePowerOn:
                        Log.e("tag", "BluetoothStatePowerOn");
                        break;
                }
            }
        });
    }

    private void getRequiredPermissions() {
        String[] requestPermissions;
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.S) {
            requestPermissions = new String[]{
                    android.Manifest.permission.BLUETOOTH_SCAN,
                    android.Manifest.permission.BLUETOOTH_CONNECT,
                    android.Manifest.permission.ACCESS_COARSE_LOCATION,
                    android.Manifest.permission.ACCESS_FINE_LOCATION
            };

        } else {
            requestPermissions = new String[]{
                    android.Manifest.permission.ACCESS_COARSE_LOCATION,
                    Manifest.permission.ACCESS_FINE_LOCATION
            };

        }
        ActivityCompat.requestPermissions(this,
                requestPermissions, REQUEST_FINE_LOCATION);
    }

    private void initListener() {

        mMtCentralManager.startScan();
        mMtCentralManager.setMTCentralManagerListener(new MTCentralManagerListener() {
            @Override
            public void onScanedPeripheral(final List<MTPeripheral> peripherals) {
                Log.e("demo11", " " + peripherals.size());
                mAdapter.setData(peripherals);
                System.out.println("Data set in the adapter");
            }
        });
        mAdapter.setOnItemClickListener(new RecycleAdapter.OnItemClickListener() {
            @Override
            public void onItemClick(View view, int position) {
                mtPeripheral = mAdapter.getData(position);
                System.out.println("Inside click listener of the adapter");
                mMtCentralManager.connect(mtPeripheral, connectionStatueListener);
            }

            @Override
            public void onItemLongClick(View view, int position) {

            }
        });
    }
    public void passwordFromUser() {
        final AlertDialog.Builder dialogBuilder = new AlertDialog.Builder(this);
        LayoutInflater inflater = this.getLayoutInflater();
        dialogBuilder.setCancelable(false);
        final View dialogView = inflater.inflate(R.layout.password_dialog, null);
        dialogBuilder.setView(dialogView);
        edtPass =  dialogView.findViewById(R.id.edtPass);

        //System.out.println("Value of userPass "+String.valueOf(userPass));
        dialogBuilder.setPositiveButton("SUBMIT", null);
        dialogBuilder.setTitle("Password Validation");
        dialogBuilder.setMessage("Please enter password to connect to bluetooth.");
        final AlertDialog b = dialogBuilder.create();
        b.show();
        Button positiveButton = b.getButton(AlertDialog.BUTTON_POSITIVE);
        //String finalUserPass = userPass;
        //password = "minew123";
        positiveButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                String userPass = edtPass.getText().toString().trim();
                System.out.println("Value of userPass "+userPass + " "+ passAvail);
                if( userPass.equals(newPass)){
                //if(userPass.equals("test")){
                    SharedPreferences.Editor editor = sharedPreferences.edit();
                    editor.putString(KEY_PASS,userPass);
                    editor.apply();
                    System.out.println("Value of KEY_PASS "+KEY_PASS);
                    Toast.makeText(MainActivity.this, "Password accepted", Toast.LENGTH_SHORT).show();
                    Intent intent2 = new Intent(MainActivity.this,DetailActivity.class);
                    startActivity(intent2);
                    b.dismiss();
                }
                else{
                    new SweetAlertDialog(MainActivity.this, SweetAlertDialog.WARNING_TYPE)
                            .setTitleText("Incorrect password")
                            .setConfirmText("OK")
                            .setContentText("The password you have entered is incorrect . Please try again!")
                            .showCancelButton(false)
                            .setConfirmClickListener(new SweetAlertDialog.OnSweetClickListener() {
                                @Override
                                public void onClick(SweetAlertDialog sDialog) {
                                    sDialog.dismiss();
                                }
                            })
                            .show();
                }
            }
        });
    }

    private ConnectionStatueListener connectionStatueListener = new ConnectionStatueListener() {
        @Override
        public void onUpdateConnectionStatus(final ConnectionStatus connectionStatus, final GetPasswordListener getPasswordListener) {
            runOnUiThread(new Runnable() {
                @Override
                public void run() {
                    switch (connectionStatus) {
                        case CONNECTING:
                            Log.e("tag", "CONNECTING");
                            Toast.makeText(MainActivity.this, "CONNECTING", Toast.LENGTH_SHORT).show();
                            break;
                        case CONNECTED:
                            Log.e("tag", "CONNECTED");
                            Toast.makeText(MainActivity.this, "CONNECTED", Toast.LENGTH_SHORT).show();
                            break;
                        case READINGINFO:
                            Log.e("tag", "READINGINFO");
                            Toast.makeText(MainActivity.this, "READINGINFO", Toast.LENGTH_SHORT).show();
                            break;
                        case DEVICEVALIDATING:
                            Log.e("tag", "DEVICEVALIDATING");
                            Toast.makeText(MainActivity.this, "DEVICEVALIDATING", Toast.LENGTH_SHORT).show();
                            break;
                        case PASSWORDVALIDATING:
                            Log.e("tag", "PASSWORDVALIDATING");
                            Toast.makeText(MainActivity.this, "PASSWORDVALIDATING", Toast.LENGTH_SHORT).show();
                            System.out.println("Value of passAvail "+ passAvail);
                            if(passAvail == null){
                                passwordFromUser();
                            }
                            else {
                                Intent intent2 = new Intent(MainActivity.this, DetailActivity.class);
                                startActivity(intent2);
                            }
                            //getPasswordListener.getPassword(password);

                            break;
                        case SYNCHRONIZINGTIME:
                            Log.e("tag", "SYNCHRONIZINGTIME");
                            Toast.makeText(MainActivity.this, "SYNCHRONIZINGTIME", Toast.LENGTH_SHORT).show();
                            break;
                        case READINGCONNECTABLE:
                            Log.e("tag", "READINGCONNECTABLE");
                            Toast.makeText(MainActivity.this, "READINGCONNECTABLE", Toast.LENGTH_SHORT).show();
                            break;
                        case READINGFEATURE:
                            Log.e("tag", "READINGFEATURE");
                            Toast.makeText(MainActivity.this, "READINGFEATURE", Toast.LENGTH_SHORT).show();
                            break;
                        case READINGFRAMES:
                            Log.e("tag", "READINGFRAMES");
                            Toast.makeText(MainActivity.this, "READINGFRAMES", Toast.LENGTH_SHORT).show();
                            break;
                        case READINGTRIGGERS:
                            Log.e("tag", "READINGTRIGGERS");
                            Toast.makeText(MainActivity.this, "READINGTRIGGERS", Toast.LENGTH_SHORT).show();
                            break;
                        case COMPLETED:
                            Log.e("tag", "COMPLETED");
                            Toast.makeText(MainActivity.this, "COMPLETED", Toast.LENGTH_SHORT).show();
                            mMtCentralManager.disconnect(mtPeripheral);
                            Intent intent = new Intent();
                            intent.setClass(MainActivity.this, DetailActivity.class);
                            intent.putExtra("mac", mac);
                            intent.putExtra("name", name);
                            intent.putExtra("battery", battery);
                            intent.putExtra("rssi", rssi);
                            intent.putExtra("xaxis", xaxis);
                            intent.putExtra("yaxis", yaxis);
                            intent.putExtra("zaxis", zaxis);
                            startActivity(intent);
                            break;
                        case CONNECTFAILED:
                        case DISCONNECTED:
                            Log.e("tag", "DISCONNECTED");
                            Toast.makeText(MainActivity.this, "DISCONNECTED", Toast.LENGTH_SHORT).show();
                            break;
                    }

                }
            });
        }

        @Override
        public void onError(MTException e) {
            Log.e("tag", e.getMessage());
        }
    };

    @Override
    public void onRequestPermissionsResult(int code, String permissions[], int[] grantResults) {
        super.onRequestPermissionsResult(code, permissions, grantResults);
        switch (code) {
//            case PERMISSION_COARSE_LOCATION:
//                if (grantResults.length > 0
//                        && grantResults[0] == PackageManager.PERMISSION_GRANTED) {
//                    initData();
//                } else {
//                    finish();
//                }
//                break;
            case REQUEST_FINE_LOCATION:
                boolean isGrant = true;
                for (int grantResult : grantResults) {
                    if (grantResult != PackageManager.PERMISSION_GRANTED) {
                        isGrant = false;
                        break;
                    }
                }
                if (isGrant) {
//                    initData();
                    if (!isBLEEnabled()) {
                        showBLEDialog();
                    } else {
                        initData();
                    }
                }
                break;
        }
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        mMtCentralManager.stopService();
    }
}